; Драйвер расширенной арифметики. Только EIS
; впервые встретился в ПЗУ А16М

; ───────────────────────────────────────────────────────────────────────────
EISData$:       .word EISDataEnd$ - EISData$
                .word HD$EIS
                .word 0
; ───────────────────────────────────────────────────────────────────────────

                nop
                ; точка входа в драйвер расширенной арифметики.
                ; вход - прерывание по вектору 10
                mov     #6, -(SP)
                add     SP, (SP)        ; тут получается значение стека до возникновения прерывания
                                        ; это нужно, если для передачи параметров eis использовался SP
                mov     R5, -(SP)
                mov     R4, -(SP)
                mov     R3, -(SP)
                mov     R2, -(SP)
                mov     R1, -(SP)
                mov     R0, -(SP)
                mov     16(SP), R5      ; берём адрес возврата из прерывания
                mov     -(R5), R0       ; получаем опкод, вызвавший прерывание
                sub     #70000, R0      ; проверим, это eis?
                cmp     R0, #4000
                blo     1$        ; да - переход
                ; нет - выходим, при этом флаги будут показывать херню,
                ; если культурно выходить по RTI
                call    EXIEIS$         ; Установка флагов и восстановление регистров из стека
                                        ; Вход: R5 - флаги
                sec
                mov     @#4, PC         ; идём обрабатывать прерывание по вектору 4

1$:             mov     R0, R1
                bic     #170777, R0     ; выделим код опкода
                swab    R0              ; вот он уже умноженный на 2
                mov     R1, R4
                bic     #177770, R1     ; выделим регистр источника
                mov     R1, R2
                asl     R1
                add     SP, R1          ; находим адрес в стеке, где находится содержимое регистра источника
                asr     R4
                asr     R4
                mov     R4, R3
                bic     #177761, R4     ; выделим код адресации источника *2
                asr     R3
                asr     R3
                asr     R3
                bic     #177761, R3     ; выделим регистр приёмника *2
                add     R4, PC
                br      EISADR01
                br      EISADR01
                br      EISADR23
                br      EISADR23
                br      EISADR45
                br      EISADR45
; ───────────────────────────────────────────────────────────────────────────
; индексная адресация
                nop                     ; EISADR6
                mov     @16(SP), R5     ; EISADR7
                                        ; берём индекс по содержимому PC
                add     #2, 16(SP)      ; прибавляем к содержимому PC два
                add     (R1), R5        ; прибавляем к индексу содержимое регистра источника
                br      EISADROP$
; ───────────────────────────────────────────────────────────────────────────
; автоинкрементная адресация

EISADR23:       mov     (R1), R5        ; берём содержимое регистра источника
                add     #2, (R1)        ; инкрементируем
                neg     R2
                br      EISADROP$
; ───────────────────────────────────────────────────────────────────────────
; автодекрементная адресация

EISADR45:       sub     #2, (R1)        ; декрементируем
                mov     (R1), R5        ; берём содержимое регистра источника
                br      EISADROP$
; ───────────────────────────────────────────────────────────────────────────
; регистровая адресация

EISADR01:       mov     R1, R5          ; берём регистр источник
EISADROP$:      bit     #2, R4          ; адресация относительная?
                beq     1$              ; нет
                mov     (R5), R5        ; да - значит получим значение по адресу значения
1$:             mov     (R5), R5
                mov     #2, R4
                bis     R3, R4
                add     SP, R3
                add     SP, R4
                mov     R2, -(SP)
                add     R0, PC
                br      EISMUL$
                br      EISDIV$
                br      EISASH$
EISASHC$:       call    EIS$SRCASH
                bpl     2$
                neg     R5
1$:             asr     R0
                ror     R1
                sob     R5, 1$
                br      0ashcmn$

2$:             beq     0ashcmn$
3$:             asl     R1
                rol     R0
                sob     R5, 3$
                br      0ashcmn$
; ───────────────────────────────────────────────────────────────────────────

EISASH$:        call    EIS$SRCASH
                bpl     2$
                neg     R5
1$:             asr     R0
                sob     R5, 1$
                br      4$

2$:             beq     4$
3$:             asl     R0
                sob     R5, 3$

4$:             mov     R3, R4
                mov     R0, R1

0ashcmn$:       rol     R5
                mov     R0, R2
                bic     #77777, R2
                add     (R3), R2
                bpl     EISEx1$
                bis     #2, R5

EISEx1$:        tst     R0
                bpl     7$
                bis     #10, R5
7$:             bne     EISEx2$
                tst     R1
                bne     EISEx2$
                bis     #4, R5
                br      EISEx2$
; ───────────────────────────────────────────────────────────────────────────

EISMUL$:        mov     R4, -(SP)
                mov     R3, -(SP)
                mov     (R3), R4
                beq     7$
                tst     R5
                beq     8$
                bpl     1$
                neg     R5
                neg     R4
                bvc     2$
                tst     (PC)+

1$:             tst     R4
2$:             sxt     R3
                clr     R0
                clr     R1
                br      5$

3$:             add     R4, R1
                adc     R0
                add     R3, R0
4$:             asl     R4
                rol     R3
                clc
5$:             ror     R5
                bcs     3$
                bne     4$
                tst     R1
                sxt     R2
                cmp     R0, R2
                beq     6$
                inc     R5
6$:             mov     (SP)+, R3
                mov     (SP)+, R4
                br      EISEx1$

7$:             clr     R5
8$:             clr     R0
                clr     R1
                br      6$
; ───────────────────────────────────────────────────────────────────────────

EISDIV$:        mov     R4, -(SP)
                mov     R3, -(SP)
                cmp     R3, R4
                beq     7$
                clr     R0
                clr     R2
                mov     (R4), R1
                mov     (R3), R4
                bpl     1$
                inc     R2
                neg     R1
                adc     R4
                neg     R4
                bvs     6$
1$:             tst     R5
                bgt     2$
                beq     11$
                dec     R2
                neg     R5
2$:             clr     R3
                inc     R0
3$:             ror     R5
                ror     R3
                cmp     R5, R4
                bgt     5$
                blt     4$
                cmp     R3, R1
                bhi     5$

4$:             sub     R3, R1
                sbc     R4
                sub     R5, R4
                sec

5$:             rol     R0
                bcc     3$
                tst     R2
                beq     8$
                neg     R0
6$:             tst     R0
                ble     EISEx3$
7$:             sev
                br      EISEx3$

8$:             tst     R0
                blt     7$

EISEx3$:        mfps    R5
                mov     (SP)+, R3
                mov     (SP)+, R4
                tst     (R3)
                bpl     EISEx2$
                neg     R1

EISEx2$:                               ; CODE XREF: RAM:7$j RAM:006526j ...
                mov     R0, (R3)
                mov     R1, (R4)
                cmp     (SP)+, #-6
                beq     12$
                call    EXIEIS$         ; Установка флагов и восстановление регистров из стека
                                        ; Вход: R5 - флаги
                rti

11$:            SEVC
                br      EISEx3$

12$:            call    EXIEIS$         ; Установка флагов и восстановление регистров из стека
                                        ; Вход: R5 - флаги
                mov     2(SP), 4(SP)
                mov     (SP)+, (SP)
                rti

; ███████████████ S U B R O U T I N E ███████████████████████████████████████


EIS$SRCASH:     bit     #40, R5
                beq     1$
                bis     #177700, R5
                br      2$

1$:             bic     #177700, R5
2$:             mov     (R3), R0
                mov     (R4), R1
                tst     R5
                return
; End of function EIS$SRCASH


; ███████████████ S U B R O U T I N E ███████████████████████████████████████

; Установка флагов и восстановление регистров из стека
; Вход: R5 - флаги

EXIEIS$:        bic     #177760, R5     ; оставляем только флаги
                bic     #17, 22(SP)     ; PS возврата из вектора 10
                bis     R5, 22(SP)      ; помещаем флаги туда
                mov     (SP)+, R5       ; адрес возврата из EXIEIS$
                mov     (SP)+, R0       ; восстанавливаем все регистры
                mov     (SP)+, R1
                mov     (SP)+, R2
                mov     (SP)+, R3
                mov     (SP)+, R4
                mov     (SP)+, (SP)
                rts     R5
; End of function EXIEIS$
EISDataEnd$:

                .end

